/*
1  ascending order on sum of the first two elements, use first element as a tie breaker
2 descending order on sum of the first two elements, use first element as a tie breaker
3  ascending order on sum of the first and third elements, use first element as a tie breaker
4  ascending order on maximum of the second and third elements, use first element as a tie breaker
5 descending order on maximum of the second and third elements, use first element as a tie breaker
6  ascending order on minimum of the first and second elements, use third element as a tie breaker
7  ascending order on first element, use second element as a tie breaker
8 descending order on third element, use first element as a tie breaker
9  ascending order on first element, use second element, in descending order, as a tie breaker
10 ascending order on product of the first two elements, use third element as a tie breaker
*/
use std::cmp::Ordering::{Less,Greater,Equal};
use std::cmp::{max,min};

fn main() {
    // selectors
    let e1 = |x: &(i32,i32,i32)| x.0;
    let e2 = |x: &(i32,i32,i32)| x.1;
    let e3 = |x: &(i32,i32,i32)| x.2;
    // reducers
    let add = std::ops::Add::add;
    let mul = std::ops::Mul::mul;
    // comparisons
    let lt  = |x: i32, y: i32| x < y;
    let gt  = |x: i32, y: i32| x > y;

    let mut a = [(3,2,4),(4,1,9),(7,6,1),(7,8,1),(0,6,4),(5,9,0),(4,1,6),(4,5,5),(2,8,5),(5,9,3),(3,2,9),(4,2,3)];
    println!("{:?}\n", a);
  
    a.sort_by( make_cmp(e1, e2, add, lt, e1, lt) );  println!("{:?}", a);
    a.sort_by( make_cmp(e1, e2, add, gt, e1, gt) );  println!("{:?}", a);
    a.sort_by( make_cmp(e1, e3, add, lt, e1, lt) );  println!("{:?}", a);
    a.sort_by( make_cmp(e2, e3, max, lt, e1, lt) );  println!("{:?}", a);
    a.sort_by( make_cmp(e2, e3, max, gt, e1, gt) );  println!("{:?}", a);
    a.sort_by( make_cmp(e1, e2, min, lt, e3, lt) );  println!("{:?}", a);
    a.sort_by( make_cmp(e1, e1, max, lt, e2, lt) );  println!("{:?}", a);
    a.sort_by( make_cmp(e3, e3, max, gt, e1, gt) );  println!("{:?}", a);
    a.sort_by( make_cmp(e1, e1, max, lt, e2, gt) );  println!("{:?}", a);
    a.sort_by( make_cmp(e1, e2, mul, lt, e3, lt) );  println!("{:?}", a);
}


fn make_cmp(s1:   fn(&(i32, i32, i32)) -> i32,   // selector 
            s2:   fn(&(i32, i32, i32)) -> i32,   // selector
            r:    fn(i32, i32)         -> i32,   // reducer
            cmp1: fn(i32, i32)         -> bool,  // comparison
            s3:   fn(&(i32, i32, i32)) -> i32,   // selector 
            cmp2: fn(i32, i32)         -> bool   // comparison
           ) -> impl (Fn(&(i32, i32, i32), &(i32, i32, i32)) -> std::cmp::Ordering) 
{   // define an anonymous lambda expression
    move |x : &(i32,i32,i32), y : &(i32,i32,i32)|          
    {
        let n1 = r(s1(&x), s2(&x));
        let n2 = r(s1(&y), s2(&y));
        let n3 = s3(&x);
        let n4 = s3(&y);
        if      cmp1(n1, n2) { Less    }
        else if cmp1(n2, n1) { Greater }
        else if cmp2(n3, n4) { Less    }
        else if cmp2(n4, n3) { Greater }
        else                 { Equal   } 
    } // return this anonymous lambda expression
} 
